<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\ChatCategory;
use Exception;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\JsonResponse;
use Yajra\DataTables\Facades\DataTables;

class ChatCategoryController extends Controller
{
    public function index()
    {
        $chat_categories = ChatCategory::orderBy('created_at', 'desc')->get();

        return view('admin.chat_categories.index', compact('chat_categories'));
    }

    public function getChatCategoryList(Request $request)
    {
        $sqlBuilder = ChatCategory::select([
            'chat_categories.id',
            'chat_categories.name',
            'chat_categories.name_ar',
            'chat_categories.status',
        ]);

        return DataTables::of($sqlBuilder)
            ->filter(function ($query) use ($request) {
                if ($request->has('search') && !empty($request->search['value'])) {
                    $query->where('chat_categories.name', 'ilike', "%" . $request->search['value'] . "%")
                    ->orWhere('chat_categories.name_ar', 'ilike', "%" . $request->search['value'] . "%");
                }
            })
            ->editColumn('status', function ($data) {
                return '<div class="status">
                <div class="form-check form-switch ">
                    <input class="form-check-input status-checkbox" type="checkbox" role="switch" id="SwitchCheck4" data-url="' . route('admin.chat_categories.status', ['id' => $data->id]) . '" data-id="' . $data->id . '" ' . (!empty($data->status) && $data->status == 1 ? 'checked' : '') . ' />
                </div>
            </div>';
            })
            ->addColumn('action', function ($data) {
                $html = '<div class="dropdown">
                                        <a href="#" class="btn btn-soft-secondary btn-sm" role="button" id="dropdownMenuLink5" data-bs-toggle="dropdown" aria-expanded="false">
                                            <i class="ri-more-2-fill"></i>
                                        </a>
                                        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink5">
                                            <li><a class="dropdown-item" href="' . route('admin.chat_categories.edit', ['id' => $data->id]) . '">Edit</a></li>
                                            <li><a class="dropdown-item delete-btn" data-url="' . route('admin.chat_categories.destroy', ['id' => $data->id]) . '">Delete</a></li>
                                        </ul>
                                    </div>';
                return $html;
            })
            ->rawColumns(['status', 'action'])
            ->make(true);
    }

    public function create()
    {
        $chat_category = "";

        return view('admin.chat_categories.create', compact('chat_category'));
    }

    public function store(Request $request)
    {
        $rules = [
            'name' => 'required|string|max:255',
            'name_ar' => 'required|string|max:255',
            'status' => 'required|in:0,1',
        ];

        $validator = Validator::make($request->all(), $rules);

        if ($validator->fails()) {
            return response()->json([
                'status' => 'error',
                'errors' => $validator->errors(),
            ], 422);
        }

        if ($request->id) {
            $chat_category = ChatCategory::find($request->id);

            if (!$chat_category) {
                return response()->json(['status' => 'error', 'message' => 'Chat Category not found'], 404);
            }

            $chat_category->name = $request->name;
            $chat_category->name_ar = $request->name_ar;
            $chat_category->status = $request->status;
            $chat_category->save();

            return response()->json(['status' => 'success', 'message' => 'Chat Category updated successfully']);
        } else {
            $chat_category = ChatCategory::create([
                'name' => $request->name,
                'name_ar' => $request->name_ar,
                'status' => $request->status,
            ]);

            return response()->json(['status' => 'success', 'message' => 'Chat Category added successfully', 'chat_category' => $chat_category]);
        }
    }

    public function edit($id)
    {
        $chat_category = ChatCategory::findOrFail($id);

        return view('admin.chat_categories.create', compact('chat_category'));
    }

    public function destroy($id): JsonResponse
    {
        try {
            $chat_category = ChatCategory::findOrFail($id);
            $chat_category->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Chat Category deleted successfully.'
            ], 200);
        } catch (ModelNotFoundException $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'Chat Category not found.'
            ], 404);
        } catch (Exception $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'An error occurred while deleting the chat category.'
            ], 500);
        }
    }

    public function statusChange(Request $request, $id)
    {
        $chat_category = ChatCategory::find($id);

        if (!$chat_category) {
            return response()->json([
                'status' => 'error',
                'message' => 'Chat Category not found.'
            ], 404);
        }

        $chat_category->status = $request->status;
        $chat_category->save();

        return response()->json([
            'status' => 'success',
            'message' => 'Chat Category status updated successfully.'
        ]);
    }
}